using MahApps.Metro.Controls;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace ZKuP
{
    /// <summary>
    /// Interaktionslogik für PrintParkausweis.xaml
    /// </summary>
    public partial class PrintParkausweis : MetroWindow
    {
        public PrintParkausweis()
        {
            InitializeComponent();

            var list = SQL.ReadSQL($"SELECT * FROM {MainWindow.table}.parkausweise WHERE Genehmigt = '1' AND Gedruckt = '0'").Result;
            dgPrint.DataContext = list;
        }

        private async void btnPrint_Click(object sender, RoutedEventArgs e)
        {
            var arr = ((sender as Button).DataContext as System.Data.DataRowView).Row.ItemArray;

            if (MessageBox.Show(this, $"Möchten Sie den Parkausweis für {arr[1].ToString()} {arr[2].ToString()} sicher drucken?", "Sicher?", MessageBoxButton.YesNo, MessageBoxImage.Question, MessageBoxResult.Yes) == MessageBoxResult.Yes)
            {
                if (Helper.OpenAndEditWord($"{arr[1].ToString()} {arr[2].ToString()}", arr[3].ToString(), arr[7].ToString(), arr[0].ToString(), Convert.ToInt16(arr[19]), arr[6].ToString()))
                {
                    if (MessageBox.Show(this, "Wurde der Parkausweis erfolgreich gedruckt?", "Erfolgreich gedruckt?", MessageBoxButton.YesNo, MessageBoxImage.Question, MessageBoxResult.No) == MessageBoxResult.Yes)
                    {
                        await SQL.WriteSQL($"UPDATE {MainWindow.table}.parkausweise SET Gedruckt = '1' WHERE idparkausweise = '{(int)arr[0]}'");
                    }
                }
                else
                {
                    if (MessageBox.Show(this, "Es wurde ein Fehler beim Vorgang festgestellt\nWurde der Parkausweis dennoch erfolgreich gedruckt?", "Fehler", MessageBoxButton.YesNo, MessageBoxImage.Warning, MessageBoxResult.No) == MessageBoxResult.Yes)
                    {
                        await SQL.WriteSQL($"UPDATE {MainWindow.table}.parkausweise SET Gedruckt = '1' WHERE idparkausweise = '{(int)arr[0]}'");
                    }
                }

                var list = SQL.ReadSQL($"SELECT * FROM {MainWindow.table}.parkausweise WHERE Genehmigt = '1' AND Gedruckt = '0'").Result;
                dgPrint.DataContext = list;
            }
        }


        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            Helper.CheckWindowIsInScreenSpace(this);
        }

        private void Window_LocationChanged(object sender, EventArgs e)
        {
            Helper.CheckWindowIsInScreenSpace(this);
        }
    }
}
